module alu(c_out,a_in,b_in,f_add,f_sub,f_and,f_or,f_not,f_xor,f_cmp,f_br,f_jmp,f_ld,f_ldi,f_ldx,f_st,f_stx,ir);
	
	parameter width = 32, prop = 19;
	
	output[width:0] c_out;
	input[width-1:0] a_in;
	input[width-1:0] b_in;
	input f_add,f_sub,f_or,f_not,f_and,f_xor,f_cmp,f_br,f_jmp,f_ld,f_ldi,f_ldx,f_st,f_stx,ir;
        reg[width:0] c_out;
  
      

always
     @(a_in or b_in or f_add or f_sub or f_and or f_or or f_not or f_cmp or
     f_br or f_jmp or f_ld or f_ldi or f_ldx or f_st or f_stx or f_xor)

   begin
	#7;
	if(f_add)
	   begin
		#(prop) c_out = a_in + b_in;
	   end
	if(f_sub)
	   begin
		#(prop) c_out = a_in - b_in;
	   end
	if(f_not)
	   begin
		#(prop) c_out[width-1:0] = ~a_in;
		c_out[width] = 0;
	   end
	if(f_and)
	   begin
		#(prop) c_out = a_in & b_in;
	   end
	if(f_or)
	   begin
		#(prop) c_out = a_in | b_in;
	   end
        if(f_cmp)
	   begin
		#(prop) c_out = a_in - b_in;
	   end
        if(f_br)
	   begin
		#(prop) c_out =  a_in + b_in;
	   end

        if(f_jmp)
	   begin
		#(prop) c_out = a_in + b_in;
	   end

        if(f_ld || f_ldi)
	   begin
		#(prop) c_out =  b_in;
	   end
        if(f_ldx)
	   begin
		#(prop) c_out = a_in + b_in;
	   end
        if(f_st)
	   begin
		#(prop) c_out =  b_in;
	   end
        if(f_stx)
	   begin
		#(prop) c_out = a_in + b_in;
	   end
        if(f_xor)
           begin
                #(prop) c_out = a_in ^ b_in;
           end   
    end

endmodule



