module checker(opcode,nop1,add1,sub1,or1,and1,not1,xor1,cmp1,br1,jmp1,ld1,ldi1,ldx1,st1,stx1,hlt1);

input [4:0]opcode;
input nop1,add1,sub1,or1,and1,not1,xor1,cmp1,br1,jmp1,ld1,ldi1,ldx1,st1,stx1,hlt1;


always @(opcode)  
       begin 
             // Check NOP
             if (opcode == 0 ) 
             begin 
                   #(7);
                   if ((nop1 != 1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("Checker Error: Check output with opcode NOP");
                         $stop;
                    end
                    else
                        $display("-I-NOP signal asserted at time    %d",$time);
             end
             
             // Check ADD
             else if (opcode == 1 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1!=1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode ADD");
                         $stop;
                    end
                    else
                        $display("-I-ADD signal asserted at time \t\t\t%d",$time);
             end
                        
             // Check SUB
             else if (opcode == 2 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1!=1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode SUB");
                         $stop;
                    end
                    else
                        $display("-I-SUB signal asserted at time \t\t\t%d",$time);
             end

             // Check OR
             else if (opcode == 3 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1!=1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode OR");
                         $stop;
                    end
                    else
                        $display("-I-OR signal asserted at  time \t\t\t%d",$time);
             end
             
             // Check AND
             else if (opcode == 4 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1!=1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode AND");
                         $stop;
                    end
                    else
                        $display("-I-AND signal asserted at time \t\t\t%d",$time);
             end
             
             // Check NOT
             else if (opcode == 5 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1!=1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode NOT");
                         $stop;
                    end
                    else
                        $display("-I-NOT signal asserted at time \t\t\t%d",$time);
             end
             
             // Check XOR
             else if (opcode == 6 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1!=1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode XOR");
                         $stop;
                    end
                    else
                        $display("-I-XOR signal asserted at time \t\t\t%d",$time);
             end
             
             // Check CMP
             else if (opcode == 7 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1!=1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode CMP");
                         $stop;
                    end
                    else
                        $display("-I-CMP signal asserted at time \t\t\t%d",$time);
             end
             
             // Check BR
             else if (opcode == 8 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1!=1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode BRX");
                         $stop;
                    end
                    else
                        $display("-I-BRX signal asserted at time \t\t\t%d",$time);
             end

             // Check JMP
             else if (opcode == 9 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1!=1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode JMP");
                         $stop;
                    end
                    else
                        $display("-I-JMP signal asserted at time \t\t\t%d",$time);
             end
             
             // Check LD
             else if (opcode == 10 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1!=1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode LD");
                         $stop;
                    end
                    else
                        $display("-I-LD signal asserted at  time \t\t\t%d",$time);
             end
             
             // Check LDI
             else if (opcode == 11 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1!=1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode LDI");
                         $stop;
                    end
                    else
                        $display("-I-LDI signal asserted at time \t\t\t%d",$time);
             end
             
             // Check LDX
             else if (opcode == 12 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1!=1) || (st1==1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode LDX");
                         $stop;
                    end
                    else
                        $display("-I-LDX signal asserted at time \t\t\t%d",$time);
             end

             // Check ST
             else if (opcode == 13 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1!=1) ||
       (stx1==1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode ST");
                         $stop;
                    end
                    else
                        $display("-I-ST signal asserted at  time \t\t\t%d",$time);
             end

             // Check STX
             else if (opcode == 14 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1!=1) || (hlt1==1))
                    begin
                         $display("-E-Checker Error: Check output with opcode STX");
                         $stop;
                    end
                    else
                        $display("-I-STX signal asserted at time \t\t\t%d",$time);
             end
             
             // Check HLT
              else if (opcode == 31 ) 
             begin 
                   #(7);
                   if ((nop1==1) || (add1==1) || (sub1==1) || (or1==1) ||
       (and1==1) || (not1==1) || (xor1==1) || (cmp1==1) || (br1==1) ||
       (jmp1==1) || (ld1==1) || (ldi1==1) || (ldx1==1) || (st1==1) ||
       (stx1==1) || (hlt1!=1))
                    begin
                         $display("-E-Checker Error: Check output with opcode HLT");
                         $stop;
                    end
                    else
                        $display("-I-HLT signal asserted at time \t\t\t%d",$time);
             end
             // Invalid opcode
             else
                $display("-I-Invalid opcode");         
       
       end

endmodule
