module checker(brcode,c,z,n,v,result,clk);

input c,z,n,v,clk;
input [3:0] brcode;
input result;
reg checkcc;

`define BRA     'b0000
`define BNV     'b1000
`define BCC     'b0001
`define BCS     'b1001
`define BVC     'b0010
`define BVS     'b1010
`define BEQ     'b0011
`define BNE     'b1011
`define BGE     'b0100
`define BLT     'b1100
`define BGT     'b0101
`define BLE     'b1101
`define BPL     'b0110
`define BMI     'b1110


always @(posedge clk)
    begin
        #(20);
        case (brcode) 

        `BRA: begin
              checkcc = 1;        
         end

        `BNV: begin
           checkcc = 0;        
        end

        `BCC: begin
           checkcc = ~c;        
        end

        `BCS: begin
           checkcc = c;        
        end

        `BVC: begin
           checkcc = ~v;        
         end

        `BVS: begin
           checkcc = v;        
        end

        `BEQ: begin
          checkcc = z;        
        end

        `BNE: begin
          checkcc = ~z;        
        end

        `BGE: begin
           checkcc = (~n & ~v) | (n & v);        
        end

        `BLT: begin
           checkcc = (n & ~v) | (~n & v);        
        end

        `BGT: begin
           checkcc = ~z & ((~n & ~v) | (n & v));        
        end

        `BLE: begin
           checkcc = z | ((n & ~v) | (~n & v));
        end
        
        `BPL: begin
           checkcc = ~n;
        end

        `BMI: begin
           checkcc = n;
        end
        
        endcase

        if (result != checkcc)
        begin
           $display("-E-TestCC output not correct. Output is %b should be %b",result,checkcc);
           $stop;
        end
        else
          $display("testcc output = %b",result);    
    end


endmodule








