module data_generator(brcode,c,z,n,v,clk);

parameter width = 32;
output [3:0] brcode;
output c,z,n,v;
input clk;

integer input_file;
integer i;
reg [3:0] brcode;
reg result,c,z,n,v;
reg [8*3:1] brstr;



initial
        begin
           input_file = $fopen("./test_vectors","r");
           if (input_file == 0)
              $stop;
            $display("BRANCH CONDITION     C     Z    N    V");
            $display("===============================================");
              
        end

always  @(posedge clk)
        begin        

                #(5);
                i = $fscanf(input_file, "%s %b %b %b %b",brstr,c,z,n,v);
                
                if(i == -1)
                     $stop;
                if (brstr == "BRA")
                begin
                   brcode = 'b0000;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end

                if (brstr == "BNV")
                begin    
                   brcode = 'b1000;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
 
                if (brstr == "BCC")
                begin
                   brcode = 'b0001;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
   
                if (brstr == "BCS")
                begin
                   brcode = 'b1001 ;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end

                if (brstr == "BVC")
                begin
                   brcode = 'b1001;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
   
                if (brstr == "BVS")
                begin
                   brcode = 'b1010;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
    
                if (brstr == "BEQ")
                begin
                   brcode = 'b1010;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
                             
                if (brstr == "BNE")
                begin
                   brcode = 'b1011;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
   
                if (brstr == "BGE")
                begin
                   brcode = 'b0100;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end

                if (brstr == "BLT")
                begin
                   brcode = 'b1100;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
                if (brstr == "BGT")
                begin
                   brcode = 'b0101 ;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end   

                if (brstr == "BLE")
                begin
                   brcode = 'b1101;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end
   
                if (brstr == "BPL")
                begin
                   brcode = 'b0110;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end   

                if (brstr == "BMI")
                begin
                   brcode = 'b1110;
                   $display("%s (%b)           %b    %b    %b   %b",brstr,brcode,c,z,n,v);
                end   


        end     
        

endmodule



